#pragma once

#include <iostream>
#include <vector>

typedef struct Node {
	int nodeID = 0;
	double x = 0, y = 0, z = 0;
	bool vertex = 0;

	/*Node() = default;
	Node(int, double, double, double, bool);*/

	friend std::ostream& operator<<(std::ostream&, const Node&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<Node>&);
}Node;

typedef struct FiniteElement {
	int elementID = 0;
	int materialID = 0;
	std::vector<int> nodesID;

	friend std::ostream& operator<<(std::ostream&, const FiniteElement&);
    friend std::ostream& operator<<(std::ostream&, const std::vector<FiniteElement>&);
	//
}FiniteElement;

typedef struct BoundaryFiniteElement : public FiniteElement {
	int boundaryID = 0;
	int surfaceID = 0;

	friend std::ostream& operator<<(std::ostream&, const BoundaryFiniteElement&);
	friend std::ostream& operator<<(std::ostream&, const std::vector<BoundaryFiniteElement>&);
}BoundaryFiniteElement;

typedef struct Edge {
	int ID_1;
	int ID_2;
	int center_ID;

	//bool operator==(const Edge&) const;
	//bool operator<(const Edge&) const;

}Edge;