#pragma once

#include <iostream>
#include <string>
#include <vector>

#include "DataStructures.h"

class MeshLoader {
protected:
    std::vector<Node> nodes;
    std::vector<FiniteElement> elements;
    std::vector<BoundaryFiniteElement> surfaces;
public:
    virtual void LoadMesh(const std::string&) = 0;
    virtual ~MeshLoader() = default;

    // ,   STL- ,     
    std::vector<Node>& getNodes();
    std::vector<FiniteElement>& getFiniteElements();
    std::vector<BoundaryFiniteElement>& getBoundaryFiniteElements();

    // ,     ID    
    std::vector<FiniteElement> getElementsByID(int, int, int);

    // ,     ,    ID  
    std::vector<FiniteElement> getElementsByEdge(int, int);

    // ,     ID  
    std::vector<FiniteElement> getElementsByOneID(int);

    // ,      ID 
    std::vector<Node> getNodesByBoundary(int);

    // ,      ID 
    std::vector<FiniteElement> getElementsByBoundary(int);

    // ,       ID 
    std::vector<BoundaryFiniteElement> getsSurfacesByBoundary(int);

    // ,         
    void insertCenterNode();

    // ,  , n -            n
    std::vector<std::vector<Node>> getNodeNeighbours();

    // ,    Node, FiniteElement  BoundaryFiniteElement  
    void Print_Data();
};